/* global PhotoGrid, FullScreenView, photosInfo */

var App = window.App = {
    init: function () {
        this.photoGrid = new PhotoGrid(document.getElementById('photos'), photosInfo, this);

        this.footer = document.querySelector('footer');
        this.footer.innerHTML = this.photoGrid.photos.length + ' photos';

        var shuffle = this.shuffleButton = document.getElementById('shuffle');
        shuffle.addEventListener('click', this);

        this.fullScreenView = new FullScreenView(document.getElementById('fullscreen'), this);
    },

    photoGridDidSelectPhoto: function (grid, photo) {
        this.currentPhoto = photo;

        this.fullScreenView.setData(photo.data);
        this.fullScreenView.transitionInFromTarget(photo);
    },

    handleEvent: function (event) {
        if (event.target === this.shuffleButton) {
            this.photoGrid.shufflePhotos();
            event.preventDefault();
        } 
		else {
            this.fullScreenView.photo.removeEventListener('click', this);
            this.fullScreenView.transitionOutToTarget(this.currentPhoto);
        }
    },

    fullScreenTransitionInWillStart: function () {
        document.body.classList.add('fullscreen');
    },

    fullScreenTransitionOutWillStart: function () {
        document.body.classList.remove('fullscreen');
    },

    fullScreenTransitionInDidComplete: function () {
        this.fullScreenView.photo.addEventListener('click', this);
    },

    fullScreenTransitionOutDidComplete: function () {
        this.fullScreenView.photo.removeEventListener('click', this);
    }
};

window.addEventListener('DOMContentLoaded', function () {
    App.init();
});
