/* global Utils */

function Photo(data) {
	this.data = data;
	this.src = data.src;

	this.element = document.createElement('div');
	this.element.className = 'photo-wrapper';
	this.element.photo = this;

	this.img = document.createElement('img');
	this.img.src = 'images/thumbnails/' + this.src;

	this.element.appendChild(this.img);

	// Fake latency when loading image.
	setTimeout(function () {
		this.img.style.opacity = 1;
	}.bind(this), Math.random() * 1000);

	if (data.comments) {
		this.element.classList.add('comments');
	}
}

Photo.prototype = {
	setSize: function (width, height) {
		this.element.style.width = width + 'px';
		this.element.style.height = height + 'px';
	},

	translate: function (x, y) {
		this.position = {x: x, y: y};
		this.element.style.webkitTransform = Utils.t2d(x, y);
	}
};
